image: docker

services:
  - docker:dind

stages:
  - qa
  - test

cache:
  paths:
    - vendor

before_script:
  - apk add make
  - make deps-install

parallel-lint:
  stage: qa
  tags: [docker]
  script: make parallel-lint

phpstan:
  stage: qa
  tags: [docker]
  script: make phpstan

copy-paste-detection:
  stage: qa
  tags: [docker]
  script: make copy-paste-detection

phploc:
  stage: qa
  tags: [docker]
  script: make phploc

metrics:
  stage: qa
  tags: [docker]
  artifacts:
    name: "phpmetrics"
    when: always
    expire_in: 2 months
    paths:
      - phpmetrics
  script: make metrics

psalm:
  stage: qa
  tags: [docker]
  script: make psalm

cs:
  stage: qa
  tags: [docker]
  script: make cs

test:
  stage: test
  tags: [docker]
  script: make test

infection:
  stage: test
  tags: [docker]
  script: make infection
